/**
 * Test case for setup.
 * Runs with mocha.
 */
'use strict'

const setup = require('../lib/setup.js')
const co = require('co');
const coz = require('coz');
const path = require('path');
const assert = require('assert');

describe('setup', () => {
  let tmpDir = `${__dirname}/../tmp`

  before(() => co(function * () {

  }))

  after(() => co(function * () {

  }))

  it('Setup', () => co(function * () {
    let buds = setup({
      name: [
        "installation",
        "build",
        "test",
        "wiki"
      ],
      pkg: require('../package.json'),
      wiki: `${__dirname}/../doc/mocks/mock-wiki/*.md`,
      links: {
        foo: 'http://example.com/foo'
      }
    })

    for (let bud of buds) {
      bud.path = path.join(tmpDir, bud.path)
      bud.mkdirp = true
      bud.force = true
      yield coz.render(bud)
    }
  }))
})

/* global describe, before, after, it */
